<?php 
interface observer {
    public function update($tabela);
}

class CacheObserver implements observer {
    public function update($tabela) {
        #odświerza cache
        echo 'cache';
    }
}

class RSSObserver implements observer {
    public function update($tabela) {
    	$baza = DB::Singleton();
    	
    	try
    	{
    		$stmt_rss = $baza->query("SELECT * FROM $tabela[0] order by data asc");
    		foreach ($stmt_rss as $news)
    		{
    			$rss[] = array(
    			'nazwa'=>$news['nazwa'],
    			'data' => $news['data'],		
  				'opis' => $news['opis'],
				'link' => "http://".$_SERVER['HTTP_HOST']."/".$tabela[0].",,".$news['id'].".html",
				'guid'=>$_SERVER['HTTP_HOST'],
				'lang'=>'en'
    			);
    		}
    		$stmt_rss->CloseCursor();
    		
    		//print_r($rss);
    		$doc = new DOMDocument('1.0','UTF-8');
				$impl = new DomImplementation;

				$doc->formatOutput = true;

				$nok = $doc->createElement("rss");
				$nok->setAttribute('version','2.0');
				$doc->appendChild($nok);


				$r = $doc->createElement( 'channel' );
				
				$gen = $doc->createElement('generator');
				$r->appendChild( $gen);
				
				$tit = $doc->createElement('title');
				$tit->appendChild(
				$doc->createTextNode("http://".$_SERVER['HTTP_HOST']));
				$gen->appendChild( $tit);
				
				$de = $doc->createElement('description');
				$de->appendChild(
				$doc->createCDATASection($tabela[0].' on '.$_SERVER['HTTP_HOST']));
				$gen->appendChild( $de);
				
				$lin = $doc->createElement('link');
				$lin->appendChild(
				$doc->createTextNode($_SERVER['HTTP_HOST']));
				$gen->appendChild( $lin);
				
				$l = $doc->createElement('language');
				$l->appendChild(
				$doc->createTextNode($item['lang']));
				$gen->appendChild( $l);
				
				

				$nok->appendChild( $r );

				$doc->appendChild( $nok );
				
				foreach( $rss as $item )
				{

					$b = $doc->createElement( "item" );
					$id = $doc->createElement( "title" );
					$id->appendChild(
					$doc->createTextNode( $item['nazwa'] )
					);
					$b->appendChild( $id );

					$name = $doc->createElement( "description" );
					$name->appendChild(
					$doc->createCDATASection($item['opis'])
					);
					$b->appendChild( $name );
					
					$data = $doc->createElement( "pubDate" );
					$data->appendChild(
					$doc->createTextNode($item['data'])
					);
					$b->appendChild( $data );
					
					$link = $doc->createElement( "link" );
					$link->appendChild(
					$doc->createTextNode($item['link'])
					);
					$b->appendChild( $link );
					
					$guid = $doc->createElement( "guid" );
					$guid->appendChild(
					$doc->createCDATASection($item['guid'])
					);
					$b->appendChild( $guid );
					
					$lang = $doc->createElement( "language" );
					$lang->appendChild(
					$doc->createCDATASection($item['lang'])
					);
					$b->appendChild( $lang );

					$gen->appendChild( $b );

				}

				$xml = $doc->saveXML();
				//print_r($xml);

				$doc->save('../'.$tabela[0].'_rss.xml');
				
				
				
    	}
    	catch(PDOException $e)
    	{
    		echo $e;
    	}
        #odświerza RSS
        
    }
}

?>