// Generated by CoffeeScript 1.7.1
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['underscore', 'config', 'controller', 'view'], function(_, Config, Controller, View) {
  var Layout;
  Layout = (function(_super) {
    __extends(Layout, _super);

    function Layout(regions) {
      this.regions = regions;
      this.currentView = [];
      this._loadingCounter = 0;
      this._loading = this.regions['loading'];
    }


    /*
    		Wypełnia wskazany region layoutu widokiem
    		@param [View] view
    		@param [string] region
    		@return [self]
     */

    Layout.prototype.set = function(view, region) {
      var bgloading, bgs, title;
      if (region == null) {
        region = 'main';
      }
      if (!(view instanceof View)) {
        throw "Podana wartość nie jest obiektem View";
      }
      if (this.currentView[region]) {
        this.currentView[region].close();
      } else {
        this.regions[region].empty();
      }
      this.regions[region].append(view.el);
      if (typeof view.onShow === "function") {
        view.onShow();
      }
      this.currentView[region] = view;
      title = view.model.config('title');
      bgs = view.model.config('bg');
      bgloading = view.model.config('bgloading');
      return this;
    };


    /*
    		Ukrywanie i wyświetlanie poszczególnych regionów
     */

    Layout.prototype.show = function(region) {
      return this.toggle(region, true);
    };

    Layout.prototype.hide = function(region) {
      return this.toggle(region, false);
    };

    Layout.prototype.toggle = function(region, visible) {
      var _ref;
      if ((_ref = this.regions[region]) != null) {
        _ref.toggleClass('isHidden', !visible);
      }
      return this;
    };


    /*
    		Dodaje do kolejki ładownia
    		@param [string] name opcjonalna nazwa do debugowania
    		@return [int]
     */

    Layout.prototype.addLoading = function(name) {
      if (name == null) {
        name = null;
      }
      ++this._loadingCounter;
      return this._checkReady();
    };


    /*
    		Usuwa z kolejki
    		@param [string] name opcjonalna nazwa do debugowania
    		@return [int]
     */

    Layout.prototype.endLoading = function(name) {
      if (name == null) {
        name = null;
      }
      --this._loadingCounter;
      return this._checkReady();
    };


    /*
    		Sprawdza czy już wszystko zostało wczytane
    		@return [int]
     */

    Layout.prototype._loadingShowTimer = null;

    Layout.prototype._checkReady = function() {
      var cfg, isLoading;
      cfg = Config.loading;
      isLoading = this._loadingCounter > 0;
      if (isLoading) {
        clearTimeout(this._loadingShowTimer);
        this._loadingShowTimer = setTimeout((function(_this) {
          return function() {
            return _this._loading.addClass(cfg.showClass);
          };
        })(this), cfg.indicatorDelay);
      } else {
        this._loading.removeClass(cfg.showClass);
        clearTimeout(this._loadingShowTimer);
      }
      this.trigger(isLoading ? 'loading:start' : 'loading:end');
      return this._loadingCounter;
    };

    return Layout;

  })(Controller);
  return new Layout(Config.regions);
});
