// Generated by CoffeeScript 1.7.1
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['jquery', 'underscore', 'backbone', 'collection', 'config', 'layout'], function($, _, Backbone, Collection, Config, Layout) {
  var Model;
  return Model = (function(_super) {
    __extends(Model, _super);

    function Model() {
      return Model.__super__.constructor.apply(this, arguments);
    }

    Model.prototype.getters = {};

    Model.prototype.setters = {};

    Model.prototype.defaultConfig = {};

    Model.prototype.toJSON = function() {
      var attr, json;
      json = _.clone(this.attributes);
      for (attr in json) {
        if ((json[attr] instanceof Model) || (json[attr] instanceof Collection)) {
          json[attr] = json[attr].toJSON();
        }
      }
      return json;
    };


    /*
    		Dodajemy ładowanie
     */

    Model.prototype.fetch = function(options, noLoading) {
      Layout.addLoading(this.url());
      return Model.__super__.fetch.call(this, options).always((function(_this) {
        return function(model, response, status) {
          Layout.endLoading(_this.url());
          if (status === 'parsererror') {
            throw new Error("Otrzymane dane od serwera są niepoprawne (JSON parser error)");
          }
        };
      })(this));
    };

    Model.prototype.get = function(attr) {
      if (_.isFunction(this.getters[attr])) {
        return this.getters[attr].call(this);
      }
      return Model.__super__.get.apply(this, arguments);
    };

    Model.prototype.set = function(key, value, options) {
      var attr, attrs;
      if (_.isObject(key) || key === null) {
        attrs = key;
        options = value;
      } else {
        attrs = {};
        attrs[key] = value;
      }
      options = options || {};
      for (attr in attrs) {
        if (_.isFunction(this.setters[attr])) {
          attrs[attr] = this.setters[attr].call(this, attrs[attr], options);
        }
      }
      return Model.__super__.set.call(this, attrs, options);
    };


    /*
    		Konfiguracja
     */

    Model.prototype.config = function(key) {
      var cfg;
      cfg = _.extend({}, this.defaultConfig, this.get('config') || {});
      return cfg[key];
    };

    return Model;

  })(Backbone.Model);
});
