// Generated by CoffeeScript 1.7.1
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

define(['underscore', 'config', 'model'], function(_, Config, Model) {
  var BlockModel;
  return BlockModel = (function(_super) {
    __extends(BlockModel, _super);

    function BlockModel() {
      return BlockModel.__super__.constructor.apply(this, arguments);
    }

    BlockModel.prototype.url = function() {
      return _.template(Config.urls.block, {
        id: this.get('id')
      });
    };

    BlockModel.prototype.defaults = {
      name: '',
      price: '',
      scope: null,
      time: 0,
      duration: 30,
      invalid: false,
      editable: true,
      movable: true,
      stretchable: false,
      stretched_by: [],
      canceled: false,
      finished: false,
      color: '#e37f00'
    };

    BlockModel.prototype.getters = {
      left: function() {
        return this.get('time') * Config.baseWidth;
      },
      width: function() {
        var duration;
        return duration = this.get('fullDuration') * Config.baseWidth;
      },
      fullDuration: function() {
        var block, duration, s, stretched_by, _i, _len;
        duration = this.get('duration');
        stretched_by = this.get('stretched_by') || [];
        for (_i = 0, _len = stretched_by.length; _i < _len; _i++) {
          s = stretched_by[_i];
          block = this.collection.get(s);
          if (block) {
            duration += block.get('duration');
          }
        }
        return duration;
      }
    };

    BlockModel.prototype.setters = {
      left: function(value) {
        value = Math.max(value, 0);
        this.set('time', Math.round(value / Config.baseWidth));
        return void 0;
      },
      width: function(value) {
        this.set('duration', Math.round(value / Config.baseWidth));
        return void 0;
      },
      duration: function(value) {
        return Math.max(1, parseInt(value, 10));
      },
      time: function(value) {
        return Math.max(0, parseInt(value, 10));
      }
    };

    BlockModel.prototype.initialize = function() {
      this.on('checkStretched', function() {
        var old, scope, stretched_by;
        scope = this.get('scope');
        old = this.toJSON();
        stretched_by = [];
        this.set({
          stretched_by: []
        }, {
          silent: true
        });
        this.collection.sort().search({
          scope: scope
        }).each((function(_this) {
          return function(block, index) {
            var enemy, my;
            my = {
              id: _this.id,
              cid: _this.cid,
              duration: _this.get('fullDuration'),
              time: _this.get('time')
            };
            enemy = {
              id: block.id,
              cid: block.cid,
              time: block.get('time'),
              duration: block.get('fullDuration')
            };
            if (my.cid === enemy.cid || block.get('stretchable') || (block.id == null)) {
              return;
            }
            if (_this._checkCollision(my, enemy)) {
              stretched_by.push(enemy.id);
            } else {
              stretched_by = _.without(stretched_by, enemy.id);
            }
            return _this.set({
              stretched_by: stretched_by
            }, {
              silent: true
            });
          };
        })(this));
        stretched_by = _.uniq(stretched_by);
        stretched_by.sort();
        if (_.isEqual(stretched_by, old.stretched_by)) {
          return;
        }
        this.trigger("change");
        return this.save({
          stretched_by: stretched_by
        }, {
          checkStretchable: false,
          info: 'after checkStretched'
        });
      });
      this.on('change:id', (function(_this) {
        return function() {
          return _this.isValid();
        };
      })(this));
      return this.on('endEdit', (function(_this) {
        return function() {
          if (!_this.isNew()) {
            return _this.save();
          }
        };
      })(this));
    };

    BlockModel.prototype.validate = function(attrs, options) {
      var error, isCollision, isFine, my;
      if (attrs == null) {
        attrs = {};
      }
      if (options == null) {
        options = {};
      }
      error = null;
      isFine = true;
      my = {
        id: this.id,
        cid: this.cid,
        scope: this.get('scope'),
        time: this.get('time'),
        duration: this.get('fullDuration'),
        stretchable: this.get('stretchable')
      };
      if (!my.scope) {
        error = "no scope";
      }
      if (my.time + my.duration > Config.max) {
        error = "out of range";
        isFine = false;
      }
      if (!this.collection) {
        return error;
      }

      /*
      				Sprawdzamy kolizję
       */
      isCollision = false;
      this.collection.sort().each((function(_this) {
        return function(block, index) {
          var enemy;
          if (my.cid === block.cid) {
            return;
          }
          enemy = {
            scope: block.get('scope'),
            time: block.get('time'),
            duration: block.get('fullDuration'),
            stretchable: block.get('stretchable')
          };
          if (enemy.scope === my.scope && _this._checkCollision(my, enemy)) {
            if ((enemy.stretchable && my.stretchable) || (!enemy.stretchable && !my.stretchable)) {
              return isCollision = true;
            }
          }
        };
      })(this));
      if (isCollision) {
        isFine = false;
        error = "collision";
      }

      /*
      				Jak nie ma kolizji to sprawdzamy czy jest streczable
      				chyba, że mamy tego nie sprawdzać, bo zapętlanie jest średnio fajne
       */
      if (!isCollision && options.checkStretchable !== false) {
        if (my.stretchable) {
          this.trigger('checkStretched');
        }
        this.collection.each((function(_this) {
          return function(block, index) {
            var enemy, _ref;
            if (my.cid === block.cid) {
              return;
            }
            enemy = {
              scope: block.get('scope'),
              time: block.get('time'),
              duration: block.get('fullDuration'),
              stretchable: block.get('stretchable')
            };
            if (enemy.scope === my.scope && _this._checkCollision(my, enemy)) {
              if (enemy.stretchable) {
                block.trigger('checkStretched');
              }
            } else {
              if (enemy.stretchable) {
                block.trigger('checkStretched');
              }
            }
            if (block.get('invalid') && (_ref = my.id, __indexOf.call(block.get('stretched_by'), _ref) >= 0)) {
              error = "siblings problem";
              return isFine = false;
            }
          };
        })(this));
      }
      this.set({
        invalid: !isFine
      });
      return error;
    };

    BlockModel.prototype.save = function(attributes, options) {
      var result, _ref;
      result = BlockModel.__super__.save.apply(this, arguments);
      if (options != null ? options.invoked : void 0) {
        return result;
      }
      if ((_ref = this.collection) != null) {
        _ref.each((function(_this) {
          return function(block) {
            if (block.id !== _this.id && block.get('invalid')) {
              return block.save(null, {
                invoked: true
              });
            }
          };
        })(this));
      }
      return result;
    };

    BlockModel.prototype._checkCollision = function(a, b) {
      return (a.time >= b.time && a.time < b.time + b.duration) || (a.time + a.duration <= b.time + b.duration && a.time + a.duration > b.time) || (a.time <= b.time && a.time + a.duration > b.time + b.duration);
    };

    return BlockModel;

  })(Model);
});
