// Generated by CoffeeScript 1.7.1
define(['jsmart', 'jquery', 'underscore', 'config', 'upcast'], function(jSmart, $, _, Config, upcast) {
  var Template, camelize, dashed, localTemplate, removeAccents, _global, _localCache;
  removeAccents = function(str) {
    var from, i, l, to;
    from = 'ąęśćóńżźł';
    to = 'aesconzzl';
    i = 0;
    l = from.length;
    while (i < l) {
      str = str.replace(new RegExp(from.charAt(i), "g"), to.charAt(i));
      i++;
    }
    return str;
  };
  camelize = function(input) {
    return input.toLowerCase().replace(/-(.)/g, function(match, group1) {
      return group1.toUpperCase();
    });
  };
  dashed = function(str) {
    return str.replace(/[^a-z0-9]+/g, ' ').replace(/^\s+|\s+$/g, '').replace(/\s+/g, '-');
  };
  localTemplate = function(name) {
    var el;
    el = $("#tpl-" + name);
    if (!el.length) {
      throw "localTemplate nie istnieje [" + name + "]";
      return false;
    }
    return $('#tpl-' + name).text();
  };
  jSmart.prototype.getTemplate = function(name) {
    name = name.replace(/\./g, '_').replace(/_tpl$/, '');
    return localTemplate(name);
  };
  jSmart.prototype.getConfig = function(name) {
    return log("WARIGN: Nie ma config loadera... więc konfiguracja '" + name + "' nie została wczytana!");
  };

  /*
  	modifier |first
   */
  jSmart.prototype.registerPlugin('modifier', 'first', function(data) {
    if (!upcast.is(data, 'array')) {
      return null;
    }
    return data[0];
  });

  /*
  	modifier |slug
   */
  jSmart.prototype.registerPlugin('modifier', 'slug', function(string) {
    if (!string) {
      return "ERROR";
    }
    return dashed(removeAccents(string.toString().toLowerCase()));
  });

  /*
  	modifier |camelize
   */
  jSmart.prototype.registerPlugin('modifier', 'camelize', function(string) {
    if (!string) {
      return "ERROR";
    }
    return camelize(dashed(removeAccents(string.toString().toLowerCase())));
  });

  /*
  	modifier |price
   */
  jSmart.prototype.registerPlugin('modifier', 'price', function(string, places, thousand, decimal) {
    var i, j, negative, number;
    number = parseFloat(string);
    places = (!isNaN(places = Math.abs(places)) ? places : 2);
    thousand = thousand || ",";
    decimal = decimal || ".";
    negative = (number < 0 ? "-" : "");
    i = parseInt(number = Math.abs(+number || 0).toFixed(places), 10) + "";
    j = ((j = i.length) > 3 ? j % 3 : 0);
    number = negative + (j ? i.substr(0, j) + thousand : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousand) + (places ? decimal + Math.abs(number - i).toFixed(places).slice(2) : "");
    return number;
  });

  /*
  	modifier |is
   */
  jSmart.prototype.registerPlugin('modifier', 'is', function(data, type) {
    if (type == null) {
      type = 'array';
    }
    if (!upcast.is(data, type)) {
      return false;
    }
    switch (type) {
      case 'array':
        if (data.length === 0) {
          return false;
        }
        break;
      case 'string':
        if ($.trim(data) === '') {
          return false;
        }
    }
    return true;
  });

  /*
  	modifier |print_r
   */
  jSmart.prototype.registerPlugin('modifier', 'print_r', function(data) {
    log('==== print_r ====');
    log(data);
    log('=================');
    return upcast.type("[[[ TYPE:" + data + " (print_r) ]]]");
  });
  _localCache = {};
  _global = {
    clipable: true,
    root: Config.root
  };

  /*
  	Silnik szablonów
  	@example
  	  tpl = new Template '<div>{$test}</div>'
  	  html = tpl.make test: 'Some example!'
   */
  return Template = (function() {

    /*
    		Tworzy nowy szablon z podanego stringa lub id
    		@param [string] html lub id
    		@param [bool] php szablon ze sklepu, wtedy trzeba podać id
    		@return [self]
     */
    function Template(tpl, php) {
      if (php) {
        if (_localCache[tpl]) {
          this.tpl = _localCache[tpl];
        } else {
          this.tpl = new jSmart(localTemplate(tpl));
          _localCache[tpl] = this.tpl;
        }
      } else {
        this.tpl = new jSmart(tpl);
      }
      this;
    }


    /*
    		Generuje HTML
    		@param [object] data
    		@return [string]
     */

    Template.prototype.make = function(data) {
      data = _.extend({}, data, _global);
      return this.tpl.fetch(data);
    };

    return Template;

  })();
});
