// Generated by CoffeeScript 1.7.1
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['backbone', 'underscore', 'template'], function(Backbone, _, Template) {
  var View;
  return View = (function(_super) {
    __extends(View, _super);

    function View() {
      return View.__super__.constructor.apply(this, arguments);
    }


    /*
    		Dodaje szablon do listy
    		@example
    		  @addTemplates
    		  	example: '<html>'
    		  	next: '<html>'
    		@param [object] tpls
    		@return [self]
     */

    View.prototype.addTemplates = function(tpls) {
      if (this.templates == null) {
        this.templates = {};
      }
      if (_.isArray(tpls)) {
        _.each(tpls, (function(_this) {
          return function(id) {
            return _this.templates[id] = new Template(id, true);
          };
        })(this));
      } else {
        _.each(tpls, (function(_this) {
          return function(html, name) {
            return _this.templates[name] = new Template(html);
          };
        })(this));
      }
      return this;
    };


    /*
    		Pobiera ze wcześniej zdefiniowanych szablon
    		następnie wypełnia nim wskazany element.
    		@example
    		  @template 'example', @model.toJSON()
    		@param [string] name
    		@param [object] data
    		@param [bool|jQuery] fill
    		@return [string]
     */

    View.prototype.template = function(name, data, fill) {
      var html, _ref;
      if (data == null) {
        data = {};
      }
      if (fill == null) {
        fill = true;
      }
      if (this.templates == null) {
        this.templates = {};
      }
      if (!this.templates[name]) {
        this.addTemplates([name]);
      }
      html = (_ref = this.templates[name]) != null ? _ref.make(data) : void 0;
      if (html && fill) {
        if (!(fill instanceof jQuery)) {
          fill = this.$el;
        }
        fill.html(html);
      }
      return html;
    };

    View.prototype.close = function() {
      this.remove();
      return this.unbind();
    };

    return View;

  })(Backbone.View);
});
