// Generated by CoffeeScript 1.7.1
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['jquery', 'underscore', 'config', 'view', 'models/block', 'collections/blocks', 'views/sideOverlay', 'views/scopes'], function($, _, Config, View, BlockModel, BlocksCollection, SideOverlayView, ScopesView) {
  var BaseView;
  return BaseView = (function(_super) {
    __extends(BaseView, _super);

    function BaseView() {
      this.syncInterval = __bind(this.syncInterval, this);
      return BaseView.__super__.constructor.apply(this, arguments);
    }

    BaseView.prototype.el = 'body';

    BaseView.prototype.events = {
      'click [data-add]': 'newBlock'
    };

    BaseView.prototype.initialize = function() {
      var isEdit;
      this.blocks = new BlocksCollection;
      this.scopes = new ScopesView({
        collection: this.blocks
      });
      isEdit = false;
      this._noDrag = true;
      this._noEdit = true;
      this._noErrors = true;
      this.listenTo(this.blocks, 'edit', function(model) {
        var _ref;
        if ((_ref = this.overlay) != null) {
          _ref.close();
        }
        this.overlay = new SideOverlayView({
          model: model
        });
        return this._noEdit = false;
      });
      this.listenTo(this.blocks, 'change:invalid', function(model, invalid) {
        return this._noErrors = !invalid;
      });
      this.listenTo(this.blocks, 'endEdit', function() {
        return this._noEdit = true;
      });
      this.listenTo(this.blocks, 'startDrag', function() {
        return this._noDrag = false;
      });
      this.listenTo(this.blocks, 'stopDrag', function() {
        return this._noDrag = true;
      });
      this.blocks.fetch().done((function(_this) {
        return function() {
          return _this.scopes.render();
        };
      })(this));
      if (Config.sync.enabled) {
        this.syncInterval();
      }
      this.lastSync = Date.now();
      return setInterval((function(_this) {
        return function() {
          var s;
          s = Math.round((Date.now() - _this.lastSync) / 1000);
          return Config.regions.lastSync.html("" + s + "s temu");
        };
      })(this), 1000);
    };

    BaseView.prototype.newBlock = function(event) {
      var _ref;
      event.preventDefault();
      if ((_ref = this.overlay) != null) {
        _ref.close();
      }
      return this.overlay = new SideOverlayView({
        model: new BlockModel
      });
    };

    BaseView.prototype.sync = function(run) {
      return this._runSync = run;
    };

    BaseView.prototype._canSync = function() {
      return this._noDrag && this._noEdit && this._noErrors;
    };

    BaseView.prototype.syncInterval = function() {
      clearTimeout(this._syncTimer);
      return this._syncTimer = setTimeout((function(_this) {
        return function() {
          if (_this._canSync()) {
            return _this.blocks.fetch({
              remove: true
            }).always(function() {
              _this.lastSync = Date.now();
              _this.syncInterval();
              return Config.regions.lastSync.html("teraz");
            });
          } else {
            return _this.syncInterval();
          }
        };
      })(this), Config.sync.delay);
    };

    BaseView.prototype.close = function() {
      this.scopes.close();
      return BaseView.__super__.close.apply(this, arguments);
    };

    return BaseView;

  })(View);
});
